//***************************************************************************
// Simple SPI master-slave hello world example
// Designed for all avr mega/tiny types. 
// When in doubt, double check the pins 
//
// @author Amir Lazarovich
// @version 0.1 2013
//**************************************************************************
#include "libs/avr-io.h"
#include "libs/usart.h"
#include "libs/spi.h"

#define BAUD 9600L
char* msg = "Hello master/slave SPI";

int main(void) {
        disableClockPrescaling();
        USART_initSerial(F_CPU, BAUD); 
        SPI_initMaster();
        
        // must come after initializing the USART serial and making sure the clock prescaler is set to 1 
        printf("\n*** MASTER mode ***\n");        

        // loop
        static unsigned char c;
        while (1) {
                if (USART_isReceiveReady()) {
                        USART_receive(&c);
                        switch (c) {
                                case 's':
                                        printf("sending on bus\n");
                                        SPI_send(msg);
                                        printf("message sent\n");
                                        break;

                                default:
                                        printf("ignoring input (psssst! try sending 's')\n");
                        }
                }
        }
}