#ifndef __avr_io_v1__
#define __avr_io_v1__

#include <avr/io.h>

#define OUTPUT 1
#define INPUT 0
#define HIGH 1
#define LOW 0

#define read(byte, pin) (byte & (1 << pin))
#define writeHigh(byte, bit) (byte |= (HIGH << bit))
#define writeLow(byte, bit) (byte &= (LOW << bit))

#define setOutput(directionPins, pin) (writeHigh(directionPins, pin))
#define setInput(directionPins, pin) (writeLow(directionPins, pin))
#define setHigh(port, pin) (writeHigh(port, pin))
#define setLow(port, pin) (writeLow(port, pin))


void disableClockPrescaling(void);


// *********************** inline avr-io.c ***********************

/**
 * set clock prescale to 1.
 * note, you need this just in case the fuse bits are incorrect
 */
void disableClockPrescaling(void) {
        CLKPR = (1 << CLKPCE);
        CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);
}

#endif